
/* ============================================================================

  pmc-4b-pci ̺귯 
  Tested compiler : VC6.0

============================================================================ */

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <windows.h>
#include <conio.h>

#include "../include/pmc4bpci.h"



#define MMC_CARD_NO		15


void WINAPI isr_sub( void )
{
	MMC_INT16U ix, iy, iz, iu;
	char buf[128];

	ix = pmc4bpci_get_interrupt(MMC_CARD_NO, PMC4BPCI_AXIS_X );
	iy = pmc4bpci_get_interrupt(MMC_CARD_NO, PMC4BPCI_AXIS_Y );
	iz = pmc4bpci_get_interrupt(MMC_CARD_NO, PMC4BPCI_AXIS_Z );
	iu = pmc4bpci_get_interrupt(MMC_CARD_NO, PMC4BPCI_AXIS_U );
	if( ix )
	{
		buf[0] = 0;
		if(ix & RR3_PULSE) sprintf(buf, "%s X:PULSE ", buf);
		if(ix & RR3_PGECM) sprintf(buf, "%s X:P>=Comp- ", buf);
		if(ix & RR3_PLCM) sprintf(buf, "%s X:P<Comp- ", buf);
		if(ix & RR3_PLCP) sprintf(buf, "%s X:P<Comp+ ", buf);
		if(ix & RR3_PGECP) sprintf(buf, "%s X:P>=Comp+ ", buf);
		if(ix & RR3_CEND) sprintf(buf, "%s X:Cont-END ", buf);
		if(ix & RR3_CSTA) sprintf(buf, "%s X:Cont-STA ", buf);
		if(ix & RR3_DEND) sprintf(buf, "%s X:Drive-End ", buf);

		printf("X:INTERRUPT STAT = 0x%04X\t", ix );
		printf(buf);
		printf("\n");
	}

	if( iy )
	{
		buf[0] = 0;
		if(iy & RR3_PULSE) sprintf(buf, "%s Y:PULSE ", buf);
		if(iy & RR3_PGECM) sprintf(buf, "%s Y:P>=Comp- ", buf);
		if(iy & RR3_PLCM) sprintf(buf, "%s Y:P<Comp- ", buf);
		if(iy & RR3_PLCP) sprintf(buf, "%s Y:P<Comp+ ", buf);
		if(iy & RR3_PGECP) sprintf(buf, "%s Y:P>=Comp+ ", buf);
		if(iy & RR3_CEND) sprintf(buf, "%s Y:Cont-END ", buf);
		if(iy & RR3_CSTA) sprintf(buf, "%s Y:Cont-STA ", buf);
		if(iy & RR3_DEND) sprintf(buf, "%s Y:Drive-End ", buf);

		printf("Y:INTERRUPT STAT = 0x%04X\t", iy );
		printf(buf);
		printf("\n");
	}

	if( iz )
	{
		buf[0] = 0;
		if(iz & RR3_PULSE) sprintf(buf, "%s Z:PULSE ", buf);
		if(iz & RR3_PGECM) sprintf(buf, "%s Z:P>=Comp- ", buf);
		if(iz & RR3_PLCM) sprintf(buf, "%s Z:P<Comp- ", buf);
		if(iz & RR3_PLCP) sprintf(buf, "%s Z:P<Comp+ ", buf);
		if(iz & RR3_PGECP) sprintf(buf, "%s Z:P>=Comp+ ", buf);
		if(iz & RR3_CEND) sprintf(buf, "%s Z:Cont-END ", buf);
		if(iz & RR3_CSTA) sprintf(buf, "%s Z:Cont-STA ", buf);
		if(iz & RR3_DEND) sprintf(buf, "%s Z:Drive-End ", buf);

		printf("Z:INTERRUPT STAT = 0x%04X\t", iz );
		printf(buf);
		printf("\n");
	}

	if( iu )
	{
		buf[0] = 0;
		if(iu & RR3_PULSE) sprintf(buf, "%s U:PULSE ", buf);
		if(iu & RR3_PGECM) sprintf(buf, "%s U:P>=Comp- ", buf);
		if(iu & RR3_PLCM) sprintf(buf, "%s U:P<Comp- ", buf);
		if(iu & RR3_PLCP) sprintf(buf, "%s U:P<Comp+ ", buf);
		if(iu & RR3_PGECP) sprintf(buf, "%s U:P>=Comp+ ", buf);
		if(iu & RR3_CEND) sprintf(buf, "%s U:Cont-END ", buf);
		if(iu & RR3_CSTA) sprintf(buf, "%s U:Cont-STA ", buf);
		if(iu & RR3_DEND) sprintf(buf, "%s U:Drive-End ", buf);

		printf("U:INTERRUPT STAT = 0x%04X\t", iu );
		printf(buf);
		printf("\n");
	}
}

void main()
{
	MMC_INT16U stat;

	stat = pmc4bpci_open(MMC_CARD_NO, isr_sub);
	if(stat!=MMC_OK)
	{
		printf("\nERROR : Can't open 'PMC-4B-PCI(ID=%d)' driver\n", MMC_CARD_NO);

		//  ̹ ݱ
		pmc4bpci_close_all();
		return;
	}

	{
		MMC_INT16U work_plane_axis[2] = {WR5_INP_AXIS1_Z,   WR5_INP_AXIS2_X};
		MMC_VERTEX p;
		MMC_INT16U axis = PMC4BPCI_AXIS_Z | PMC4BPCI_AXIS_X;

		// ͷƮ ߻ (PULSE)
		pmc4bpci_enable_interrupt(MMC_CARD_NO, axis, INT_PGECM | INT_PLCM | INT_PLCP | INT_PGEP | INT_CEND | INT_CSTA | INT_DEND );

		// COMP+  1250 
		pmc4bpci_set_compplus(MMC_CARD_NO, axis, 1250);

		// COMP-  1250 
		pmc4bpci_set_compminus(MMC_CARD_NO, axis, -1250);

		// 2   ̺
		p.x = 5000, p.y = -5000;
		pmc4bpci_pos_imove2(MMC_CARD_NO, work_plane_axis, &p);

		//  ⶧ ٸ
		pmc4bpci_wait(MMC_CARD_NO, axis );

		// 2   ̺
		p.x = -5000, p.y = 5000;
		pmc4bpci_pos_imove2(MMC_CARD_NO, work_plane_axis, &p);

		//  ⶧ ٸ
		pmc4bpci_wait(MMC_CARD_NO, axis );
	}

	//  ̹ ݱ
	pmc4bpci_close_all();
}
