

#include <stdio.h> 
#include <windows.h> 
#include "../include/pmc4bpci.h"

#include <conio.h>



void readRR(int no, int axis);
void wreg1_N( int no, int axis, int wdata );
void wreg2_N( int no, int axis, int wdata );
void wreg3_N( int no, int axis, int wdata );
void command_N( int no, int axis, int cmd );
void range_N( int no, int axis, long wdata );
void acac_N( int no, int axis, int wdata );
void acc_N( int no, int axis, int wdata );
void dec_N( int no, int axis, int wdata );
void startv_N( int no, int axis, int wdata );
void speed_N( int no, int axis, int wdata );
void pulse_N( int no, int axis, long wdata );
void decp_N( int no, int axis, long wdata );
void center_N( int no, int axis, long wdata );
void lp_N( int no, int axis, long wdata );
void ep_N( int no, int axis, long wdata );
void compp_N( int no, int axis, long wdata );
void compm_N( int no, int axis, long wdata );
void accofst_N( int no, int axis, long wdata );
long readlp_N( int no, int axis );
long readep_N( int no, int axis );
void wait_N( int no, int axis );
void next_wait_N( int no );
void bp_wait_N( int no );
int init();
void close();
int inwN(int no, WORD iocc);
void outwN(int no, WORD iocc, int data);


HMODULE g_pDll = NULL;



typedef void (*F1)( int no, WORD iocc, int data ); // OutW_N
typedef WORD (*F2)( int no, WORD iocc ); // InW_N
typedef int (*F3)( void ); // CloseCard_all
typedef HANDLE (*F4)( int no, void (__stdcall *isr)(void), int base_addr, int size, int irq); // OpenCard_N
typedef char* (*F5)( void ); // ValidString

F1 _OutW_N = NULL;
F2 _InW_N = NULL;
F3 _CloseCard_all = NULL;
F4 _OpenCard_N = NULL;
F5 _ValidString = NULL;

int int_flg[MAX_CARD] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int BoardOk[MAX_CARD] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int index[MAX_CARD] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
unsigned short m_rr[4][8] = { 0, };
int m_no = 0;


void isr_sub( int no )
{
	int_flg[ no ] = 1;
	command_N( no, 0x1, 0x0f );
	_InW_N( no, RR3 );
	command_N( no, 0x1, 0x0f );
	_OutW_N( no, WR3, 0x0100 );
}

void __stdcall isr0(void){	isr_sub( 0 );}
void __stdcall isr1(void){	isr_sub( 1 );}
void __stdcall isr2(void){	isr_sub( 2 );}
void __stdcall isr3(void){	isr_sub( 3 );}
void __stdcall isr4(void){	isr_sub( 4 );}
void __stdcall isr5(void){	isr_sub( 5 );}
void __stdcall isr6(void){	isr_sub( 6 );}
void __stdcall isr7(void){	isr_sub( 7 );}
void __stdcall isr8(void){	isr_sub( 8 );}
void __stdcall isr9(void){	isr_sub( 9 );}
void __stdcall isr10(void){	isr_sub( 10 );}
void __stdcall isr11(void){	isr_sub( 11 );}
void __stdcall isr12(void){	isr_sub( 12 );}
void __stdcall isr13(void){	isr_sub( 13 );}
void __stdcall isr14(void){	isr_sub( 14 );}
void __stdcall isr15(void){	isr_sub( 15 );}


///////////////////
void readRR(int no, int axis) // axis=x:0,y:1,z:2,u:3
{
	int i;
	int t = (0x01 << axis) & 0x0f;
	WORD addr[8] = {RR0, RR1, RR2, RR3, RR4, RR5, RR6, RR7};
	_OutW_N( no, WR0,( t << 8 )+ 0xf );
	for(i=0;i<8;i++)
		m_rr[axis][i] = _InW_N( no, addr[i] );
}

void wreg1_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	_OutW_N( no, WR0,( axis << 8 )+ 0xf );
	_OutW_N( no, WR1, wdata );
}

void wreg2_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	_OutW_N( no, WR0,( axis << 8 )+ 0xf );
	_OutW_N( no, WR2, wdata );
}

void wreg3_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	_OutW_N( no, WR0,( axis << 8 )+ 0xf );
	_OutW_N( no, WR3, wdata );
}

void command_N( int no, int axis, int cmd )
{
	axis &= 0x0f;
	_OutW_N( no, WR0,( axis << 8 )+ cmd );
}

void range_N( int no, int axis, long wdata )
{
	axis &= 0x0f;
	if( wdata < 1 )
		wdata = 1;
	if( wdata > 8000000L )
		wdata = 8000000L;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis << 8 )+ 0x00 );
}

void acac_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	if( wdata > 65535L )
		wdata = 65535L;
	if( wdata < 1 )
		wdata = 1;

	_OutW_N( no, WR6, wdata );
	_OutW_N( no, WR0,( axis << 8 )+ 0x01 );
}

void acc_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	if( wdata > 8000 )
		wdata = 8000;
	if( wdata < 1 )
		wdata = 1;

	_OutW_N( no, WR6, wdata );
	_OutW_N( no, WR0,( axis << 8 )+ 0x02 );
}

void dec_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	if( wdata > 8000 )
		wdata = 8000;
	if( wdata < 1 )
		wdata = 1;

	_OutW_N( no, WR6, wdata );
	_OutW_N( no, WR0,( axis << 8 )+ 0x03 );
}

void startv_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	if( wdata > 8000 )
		wdata = 8000;
	if( wdata < 1 )
		wdata = 1;

	_OutW_N( no, WR6, wdata );
	_OutW_N( no, WR0,( axis << 8 )+ 0x04 );
}

void speed_N( int no, int axis, int wdata )
{
	axis &= 0x0f;
	if( wdata > 8000 )
		wdata = 8000;
	if( wdata < 1 )
		wdata = 1;

	_OutW_N( no, WR6, wdata );
	_OutW_N( no, WR0,( axis << 8 )+ 0x05 );
}

void pulse_N( int no, int axis, long wdata )
{
	axis &= 0x0f;
	if( wdata < -8388608L )
		wdata = -8388608L;
	if( wdata > 268435455L )
		wdata = 268435455L;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis << 8 )+ 0x06 );
}

void decp_N( int no, int axis, long wdata )
{
	axis &= 0x0f;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0x7 );
}

void center_N( int no, int axis, long wdata )
{
	axis &= 0x0f;
	if( wdata < -8388608L )
		wdata = -8388608L;
	if( wdata > 8388607L )
		wdata = 8388607L;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0x8 );
}

void lp_N( int no, int axis, long wdata )
{
	axis &= 0x0f;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0x9 );
}

void ep_N( int no, int axis, long wdata )
{
	axis &= 0x0f;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0xa );
}

void compp_N( int no, int axis, long wdata )
{
	axis &= 0x0f;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0xb );
}

void compm_N( int no, int axis, long wdata )
{
	axis &= 0x0f;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0xc );
}

void accofst_N( int no, int axis, long wdata )
{
	axis &= 0x0f;

	_OutW_N( no, WR7,( wdata >> 16 )& 0x0ffff );
	_OutW_N( no, WR6, wdata & 0x0ffff );
	_OutW_N( no, WR0,( axis <<  8 )+ 0xd );
}

long readlp_N( int no, int axis )
{
	long	a, d6, d7;

	axis &= 0x0f;
	_OutW_N( no, WR0,( axis << 8 )+ 0x10 );
	d6 = _InW_N( no, RR6 );
	d7 = _InW_N( no, RR7 );
	a = d6 +( d7 << 16 );
	return( a );
}

long readep_N( int no, int axis )
{
	long	a, d6, d7;

	axis &= 0x0f;

	_OutW_N( no, WR0,( axis << 8 )+ 0x11 );
	d6 = _InW_N( no, RR6 );
	d7 = _InW_N( no, RR7 );
	a = d6 +( d7 << 16 );
	return( a );
}

void wait_N( int no, int axis )
{
	axis &= 0x0f;

	while( _InW_N( no, RR0 )& axis );
}

void next_wait_N( int no )
{
	while(( _InW_N( no, RR0 )& 0x0200 )== 0 );
}

void bp_wait_N( int no )
{
	while(( _InW_N( no, RR0 )& 0x6000 )== 0x6000 );
}

int init()
{
	HANDLE		ists;
	int			no;
	int			cnt;

	_OutW_N = NULL;
	_InW_N = NULL;
	_CloseCard_all = NULL;
	_OpenCard_N = NULL;
	_ValidString = NULL;

	g_pDll = LoadLibrary("pmc4bpci.dll");
	if(!g_pDll) return 0;


	_OutW_N = (F1)GetProcAddress(g_pDll, "OutW_N");
	_InW_N = (F2)GetProcAddress(g_pDll, "InW_N");
	_CloseCard_all = (F3)GetProcAddress(g_pDll, "CloseCard_all");
	_OpenCard_N = (F4)GetProcAddress(g_pDll, "OpenCard_N");
	_ValidString = (F5)GetProcAddress(g_pDll, "ValidString");

	if(!_OutW_N || !_InW_N || !_CloseCard_all || !_OpenCard_N)
	{
		_OutW_N=NULL;
		_InW_N=NULL;
		_CloseCard_all=NULL;
		_OpenCard_N=NULL;
		_ValidString=NULL;

		FreeLibrary(g_pDll);
		g_pDll = NULL;

		printf("Can't loading 'Function'!\n");
		return 0;
	}

	m_no = 0;

	for( no = 0; no < MAX_CARD; no++ ){
		int_flg[ no ]= 0;
		ists = NULL;
		switch( no ){
			case 0:		ists = _OpenCard_N( no, isr0, 0, 0, 0 );	break;
			case 1:		ists = _OpenCard_N( no, isr1, 0, 0, 0  );	break;
			case 2:		ists = _OpenCard_N( no, isr2, 0, 0, 0  );	break;
			case 3:		ists = _OpenCard_N( no, isr3, 0, 0, 0  );	break;
			case 4:		ists = _OpenCard_N( no, isr4, 0, 0, 0  );	break;
			case 5:		ists = _OpenCard_N( no, isr5, 0, 0, 0  );	break;
			case 6:		ists = _OpenCard_N( no, isr6, 0, 0, 0  );	break;
			case 7:		ists = _OpenCard_N( no, isr7, 0, 0, 0  );	break;
			case 8:		ists = _OpenCard_N( no, isr8, 0, 0, 0  );	break;
			case 9:		ists = _OpenCard_N( no, isr9, 0, 0, 0  );	break;
			case 10:	ists = _OpenCard_N( no, isr10, 0, 0, 0  );	break;
			case 11:	ists = _OpenCard_N( no, isr11, 0, 0, 0  );	break;
			case 12:	ists = _OpenCard_N( no, isr12, 0, 0, 0  );	break;
			case 13:	ists = _OpenCard_N( no, isr13, 0, 0, 0  );	break;
			case 14:	ists = _OpenCard_N( no, isr14, 0, 0, 0  );	break;
			case 15:	ists = _OpenCard_N( no, isr15, 0, 0, 0  );	break;
		}
		if( ists == NULL ){

			BoardOk[ no ] = 0;
		} else {
			printf("Open card no : <%d>\n", no);

			BoardOk[ no ] = 1;
			index[ m_no ] = no;
			m_no++;

			_OutW_N( no, WR0, 0x8000);

			for(cnt =0; cnt < 10000; ++cnt);

			wreg1_N( no, 0xf, 0x0000 );
			wreg2_N( no, 0xf, 0x0000 );
			wreg3_N( no, 0xf, 0x0000 );

			accofst_N( no, 0xf, 0 );
			range_N( no, 0xf, 800000L );
			acac_N( no, 0xf, 1010 );
			acc_N( no, 0xf, 400 );
			dec_N( no, 0xf, 400 );
			startv_N( no, 0xf, 100 );
			speed_N( no, 0xf, 4000 );
			pulse_N( no, 0xf, 32000 );
			lp_N( no, 0xf, 0 );
			ep_N( no, 0xf, 0 );
		}
	}

	return m_no;
}

void close()
{
	if(g_pDll)
	{
		_CloseCard_all();
		FreeLibrary(g_pDll);
	}
	g_pDll = NULL;
}

int inwN(int no, WORD iocc)
{
	return _InW_N(no, iocc);
}

void outwN(int no, WORD iocc, int data)
{
	_OutW_N(no, iocc, data);
}

void main(void)
{
	int card_no;

	card_no = init();

	printf("Total count = (%d) OK!\n", card_no);

	//...

	close();
}
